Bug 620842 - (PyCObject) Check/port usage of deprecation PyCObject_ API
Check/port usage of deprecation PyCObject_ API
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: python (Show other bugs)
14
All Linux
low Severity medium
: ---
: ---
Assigned To: Dave Malcolm
Fedora Extras Quality Assurance
:
Depends On: 621887 623844 623852 623853 623854 623855 623856 623857 623858 623859 623860 623863 623864 623865 623867 624674 640432 652368
Blocks: Python27
  Show dependency treegraph
 
Reported: 2010-08-03 11:53 EDT by Dave Malcolm
Modified: 2012-08-16 14:01 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-16 14:01:56 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Users of PyCObject_ symbols on a partial install of rawhide (12.26 KB, text/plain)
2010-08-03 11:58 EDT, Dave Malcolm
no flags Details

  None (edit)
Description Dave Malcolm 2010-08-03 11:53:52 EDT
Python 2.7 deprecated the PyCObject API in favor of a new "capsule" API.

The deprecations are set to "ignore" by default.

However the deprecation caused at least one app to fail (virt-manager, see bug 620216, due to it modifying the warning settings), so it seems worth doublechecking the scope of usage of PyCObject, and pro-actively porting things.
Comment 1 Dave Malcolm 2010-08-03 11:58:34 EDT
Created attachment 436309 [details]
Users of PyCObject_ symbols on a partial install of rawhide

Output from:
  for f in $(find /usr/lib64/python2.7/site-packages/ -name "*.so") ; do
   (eu-readelf -s $f | grep PyCObject_) && printf "$f\n\n" ; 
  done

on a partial install of rawhide.
Comment 2 Dave Malcolm 2010-08-03 12:13:03 EDT
Upstream notes: http://docs.python.org/dev/whatsnew/2.7.html#capsules

Unfortunately this may introduce ABI interdependencies between packages that aren't expressible with the rpm metadata as-is.

The capsules are named at the python level, so we could use:
  Provides:  python-capsule(2.7, "_GTK_API")
or somesuch.

(I'm not sure that this works, though; if a producer/consumer pair don't sync up on their usage of the API, will this segfault?  Need to check)
Comment 3 Dave Malcolm 2010-08-12 19:50:56 EDT
Running the list from comment #1 through "| xargs rpm -qf | sort |uniq" gives this list of 22 RPMs (this is on a partial install):
dbus-python-0.83.0-7.fc14.x86_64
gnome-python2-canvas-2.28.1-3.fc14.x86_64
gnome-python2-gconf-2.28.1-3.fc14.x86_64
gnome-python2-gnome-2.28.1-3.fc14.x86_64
gnome-python2-gnomekeyring-2.31.1-3.fc14.x86_64
gnome-python2-gnomevfs-2.28.1-3.fc14.x86_64
gtk-vnc-python-0.4.1-3.fc14.x86_64
libselinux-python-2.0.96-3.fc14.x86_64
libvirt-python-0.8.2-3.fc14.x86_64
libxml2-python-2.7.7-2.fc14.x86_64
numpy-1.4.1-6.fc14.x86_64
pycairo-1.8.8-2.fc14.x86_64
pygobject2-2.21.5-3.fc14.x86_64
pygtk2-2.17.0-7.fc14.x86_64
pygtk2-libglade-2.17.0-7.fc14.x86_64
pyOpenSSL-0.9-2.fc14.x86_64
python-imaging-1.1.7-2.fc14.x86_64
python-krbV-1.0.90-2.fc14.x86_64
python-libguestfs-1.5.2-4.fc14.x86_64
rpm-python-4.8.1-4.fc14.x86_64
subversion-1.6.12-3.fc14.x86_64
vte-0.25.1-2.fc14.x86_64

Running it through:
  | xargs rpm -qf --qf="%{SOURCERPM}\n" | sort | uniq
gives 18 source rpms:
gtk-vnc-0.4.1-3.fc14.src.rpm
libguestfs-1.5.2-4.fc14.src.rpm
libselinux-2.0.96-3.fc14.src.rpm
libvirt-0.8.2-3.fc14.src.rpm
libxml2-2.7.7-2.fc14.src.rpm
numpy-1.4.1-6.fc14.src.rpm
pycairo-1.8.8-2.fc14.src.rpm
pygobject2-2.21.5-3.fc14.src.rpm
pygtk2-2.17.0-7.fc14.src.rpm
pyOpenSSL-0.9-2.fc14.src.rpm
python-imaging-1.1.7-2.fc14.src.rpm
python-krbV-1.0.90-2.fc14.src.rpm
rpm-4.8.1-4.fc14.src.rpm
subversion-1.6.12-3.fc14.src.rpm
vte-0.25.1-2.fc14.src.rpm
Comment 4 Fedora End Of Life 2012-08-16 14:01:59 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Note You need to log in before you can comment on or make changes to this bug.